# t33l.s - ʃ[h #16  768x528 ɕύX.
# Copyright (C) 2002 Tachibana Eriko
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA


program:	.reg	't33l'
version:	.reg	'1.01'
date:		.reg	'2002/05/25'
author:		.reg	'Ԃq'


		.include	macro.mac
		.include	console.mac
		.include	doscall.mac
		.include	iocscall.mac


IOCS_ROM_ADDR:	.equ	$ff0000
IOCS_ROM_SIZE:	.equ	 $10000


		.text
		.even
start:
		suba.l	a5,a5			;s\1
		suba.l	a6,a6			;s\2

		clr.l	-(sp)
		DOS	_SUPER

		cmpi.b	#3,($cbc)
		bcs	not_writable

		lea	(orig_data,pc),a1
		lea	(patch_data,pc),a2

		lea	(IOCS_ROM_ADDR),a0
		move	(a1),d0
		move	#(IOCS_ROM_SIZE-DATA_SIZE)/2,d1
search_loop:
		cmp	(a0)+,d0
		dbeq	d1,search_loop
		bne	not_found

		moveq	#0,d7
		moveq	#DATA_SIZE/2-1,d0
		bsr	compare_data
		beq	found
		moveq	#1,d7
		exg	a1,a2
		moveq	#DATA_SIZE/2-1,d0
		bsr	compare_data
		beq	found
		exg	a1,a2
		bra	search_loop
not_found:
		pea	(not_found_mes,pc)
		bra	@f
not_writable:
		pea	(not_wr_mes,pc)
@@:
		bsr	print_title
		DOS	_PRINT
		move	#1,(sp)
		DOS	_EXIT2
found:
		subq.l	#2,a0

		lea	(a0),a1			;_AhX
		move	#$f000,d1		;AhX߂
		IOCS	_SYS_STAT
		tst.l	d0
		bmi	not_writable		;G[
		cmpa.l	d0,a1
		beq	not_writable		;{ ROM wĂ

* pb`f[^
		movea.l	d0,a0
		moveq	#DATA_SIZE/2-1,d1
		bsr	disable_cache
		PUSH_SR_DI
		.cpu	68030
		movec	dfc,d2
		moveq	#%011,d0		;MMU Data
		movec	d0,dfc
@@:
		move	(a2)+,d0
		moves	d0,(a0)+
		dbra	d1,@b
		movec	d2,dfc
		.cpu	68000
		POP_SR
		bsr	restore_cache

		lea	(patch_mes,pc),a5
		tst	d7
		beq	@f
		lea	(dispatch_mes,pc),a5
@@:
* GraphicMask ̃pb`
		move.l	#'gm'<<16+$ff80,d1
		IOCS	_TGUSEMD
		tst.l	d0
		bmi	no_gm

		movea.l	($400+_CRTMOD*4),a0
		movea.l	($400+_TGUSEMD*4),a1
		cmpa.l	a0,a1			;NEW_CRTMOD < NEW_TGUSEMD
		bls	no_gm			;łȂ΂ȂȂ
		lea	($800,a0),a2
		cmpa.l	a1,a2			;NEW_TGUSEMD < NEW_CRTMOD+$800
		bls	no_gm			;łȂ΂ȂȂ

		move.l	a1,d1
		sub.l	a0,d1
		lsr.l	#1,d1			;[h

		move	(gm_orig_data,pc),d0
gm_search_loop:
		cmp	(a0)+,d0
		dbeq	d1,gm_search_loop
		bne	gm_not_found

		lea	(gm_orig_data,pc),a1
		lea	(gm_patch_data,pc),a2
		tst	d7
		beq	@f
		exg	a1,a2
@@:
		moveq	#GM_DATA_SIZE/2-1,d0
		bsr	compare_data
		bne	gm_search_loop
		bra	gm_found
gm_not_found:
		lea	(gm_not_found_mes,pc),a6
		bra	no_gm
gm_found:
		subq.l	#2,a0

* pb`f[^
		moveq	#GM_DATA_SIZE/2-1,d1
		bsr	disable_cache
		PUSH_SR_DI
@@:
		move	(a2)+,(a0)+
		dbra	d1,@b
		POP_SR
		bsr	restore_cache

		lea	(gm_patch_mes,pc),a6
		tst	d7
		beq	@f
		lea	(gm_dispatch_mes,pc),a6
@@:
no_gm:
		move.l	#16<<16+0,-(sp)		;768x512,g-off
		DOS	_CONCTRL
		addq.l	#4,sp

		bsr	print_title
		move.l	a5,-(sp)
		beq	@f
		DOS	_PRINT
@@:
		move.l	a6,(sp)
		beq	@f
		DOS	_PRINT
@@:
		DOS	_EXIT


* ^Cg\
print_title:
		pea	(t33l_mes,pc)
		DOS	_PRINT
		addq.l	#4,sp
		rts


* f[^r
* in	d0.l	r[h
*	a0.l	rf[^擪[hAhX+2
*	a1.l	rf[^(orig_data or patch_data)
* out	d0.l	0:v -1:sv
*	ccr	<tst.l d0> ̌

compare_data:
		PUSH	a0-a1
		subq.l	#2,a0
@@:
		cmpm	(a0)+,(a1)+
		dbne	d0,@b
		bne	cmp_data_ne
		moveq	#0,d0
		bra	@f
cmp_data_ne:
		moveq	#-1,d0
@@:		POP	a0-a1
		rts


* LbVIt
disable_cache:
		PUSH	d0-d2/a0
		moveq	#1,d1
		IOCS	_SYS_STAT
		lea	(cache_mode,pc),a0
		move.l	d0,(a0)
		moveq	#0,d2
		bra	@f
* LbVA
restore_cache:
		PUSH	d0-d2/a0
		move.l	(cache_mode,pc),d2
@@:
		moveq	#4,d1
		IOCS	_SYS_STAT
		POP	d0-d2/a0
		rts

cache_mode:	.ds.l	1


		.data

		.even
orig_data:
		.dc	$316,137
		.dc	14,28,124,567,5,40,552,27
		.dc.b	$ff,$ff,$ff,$ff
		.dc	1024,768,512,1
DATA_SIZE:	.equ	$-orig_data

patch_data:
		.dc	$316,137
		.dc	14,28,124,567,5,40-8,552+8,27
		.dc.b	$ff,$ff,$ff,$ff
		.dc	1024,768,512,1

gm_orig_data:
	.irp	data,$89_000e,$1c_007c,$237_0005,$28_0228,$1b_0000
		move.l	#data,(a0)+
	.endm
GM_DATA_SIZE:	.equ	$-gm_orig_data

gm_patch_data:
	.irp	data,$89_000e,$1c_007c,$237_0005,$28_0228-8<<16+8,$1b_0000
		move.l	#data,(a0)+
	.endm


t33l_mes:	.dc.b	program,' version ',version,'  ',date,' ',author,'.',CRLF,0
patch_mes:	.dc.b	'ʃ[h #16  768x528 Ɋg܂.',CRLF,0
dispatch_mes:	.dc.b	'ʃ[h #16  768x512 ɖ߂܂.',CRLF,0
not_wr_mes:	.dc.b	'IOCS ROM ɏ߂܂.',CRLF,0
not_found_mes:	.dc.b	'CRTC ݒf[^t܂ł.',CRLF,0
gm_patch_mes:	.dc.b	'(GraphicMask)ʃ[h #16  768x528 Ɋg܂.',CRLF,0
gm_dispatch_mes:.dc.b	'(GraphicMask)ʃ[h #16  768x512 ɖ߂܂.',CRLF,0
gm_not_found_mes:
		.dc.b	'(GraphicMask)CRTC ݒf[^t܂ł.',CRLF,0


		.end
